# -------------------------------------------------
# This workflow runs Parasoft Jtest analysis with selected build tool (maven, gradle, etc)
# For details on how to configure your project with Jtest please refer to the Jtest examples README file
# -------------------------------------------------
# Prerequisites:
# 1. Set up the Jtest license and other settings in jtestcli.properties in the Jtest installation directory
# 2. Include 'sast' value for report.format key in the settings (e.g. report.format=html,pdf,sarif,sast)

stages:
- test

jtest-sast:
  stage: test
  tags:
  - jtest
  script:
  - git checkout main
  - git pull
  - cd jtest-demo
  - echo "$HOME"
  - whoami
  - pwd

  # -------------------------------------------------
  # Running with Maven
  # Prerequisites:\
  # 1. Configure your Maven setup by following the Jtest User Guide:
  # https://docs.parasoft.com/display/JTEST20202/Configuring+the+Jtest+Plugin+for+Maven
  # 2. Uncomment the following to run the "Recommended Rules" test configuration:
  - ./mvnw jtest:jtest -Dproperty.report.format=sast-gitlab -Dproperty.jtest.showsettings=true
  #./mvnw clean jtest:jtest "-Djtest.config=builtin://Unit Tests" "-Djtest.report.format=xunit"
  # or uncomment the following to run the specified test configuration:
  # - ./mvnw clean jtest:jtest "-Djtest.config=builtin://Recommended Rules"

  #- cd target/jtest
  #- PASS=$({grep -Po 'Passed.* pass="\K\d+' target/jtest/report.xml || echo "0"})
  #- PASS=$(printf "%-5s" "$PASS")
  #- TOTALVIOLS=$(grep -Po "<Project bdCheckedFiles.* totErrs="\K\d+" report.xml || echo "0")
  #- SUPPS=$(grep -Po '<Project bdCheckedFiles.* suppErrs="\K\d+' report.xml || echo "0")
  #- echo "VIOLS $TOTALVIOLS"
  #- echo "SUPPS $SUPPS"
  allow_failure: true
  artifacts:
    when: always
    paths:
    - ./jtest-demo/target/jtest/report.sast
    - ./jtest-demo/target/jtest/report.xml
    reports:
      sast: ./jtest-demo/target/jtest/report.sast
